function preprocessedData=PreproceessData(InputImage,preprocessedthreshold)

% InputImage=uint8(InputImage);
inputsize=size(InputImage);
tempImage=zeros(inputsize);
tempImage=uint8(tempImage);
%smoothing
fprintf('Smoothing data 1st time... \n')
tempImage(2:end-1,2:end-1,2:end-1)=1/27*InputImage(2:end-1,2:end-1,2:end-1)...%1
+1/27*InputImage(1:end-2,1:end-2,1:end-2)...%2
+1/27*InputImage(1:end-2,1:end-2,2:end-1)...%3
+1/27*InputImage(1:end-2,1:end-2,3:end)...%4
+1/27*InputImage(1:end-2,2:end-1,1:end-2)...%5
+1/27*InputImage(1:end-2,2:end-1,2:end-1)...%6
+1/27*InputImage(1:end-2,2:end-1,3:end)...%7
+1/27*InputImage(1:end-2,3:end,1:end-2)...%8
+1/27*InputImage(1:end-2,3:end,2:end-1)...%9
+1/27*InputImage(1:end-2,3:end,3:end)...%10
+1/27*InputImage(2:end-1,1:end-2,1:end-2)...%11
+1/27*InputImage(2:end-1,1:end-2,2:end-1)...%12
+1/27*InputImage(2:end-1,1:end-2,3:end)...%13
+1/27*InputImage(2:end-1,2:end-1,1:end-2)...%14
+1/27*InputImage(2:end-1,2:end-1,3:end)...%15
+1/27*InputImage(2:end-1,3:end,1:end-2)...%16
+1/27*InputImage(2:end-1,3:end,2:end-1)...%17
+1/27*InputImage(2:end-1,3:end,3:end)...%18
+1/27*InputImage(3:end,1:end-2,1:end-2)...%19
+1/27*InputImage(3:end,1:end-2,2:end-1)...%20
+1/27*InputImage(3:end,1:end-2,3:end)...%21
+1/27*InputImage(3:end,2:end-1,1:end-2)...%22
+1/27*InputImage(3:end,2:end-1,2:end-1)...%23
+1/27*InputImage(3:end,2:end-1,3:end)...%24
+1/27*InputImage(3:end,3:end,1:end-2)...%25
+1/27*InputImage(3:end,3:end,2:end-1)...%26
+1/27*InputImage(3:end,3:end,3:end);%27


InputImage(tempImage>preprocessedthreshold)=255;
InputImage(tempImage<=preprocessedthreshold)=0;

InputImage=uint8(InputImage);
tempImage=uint8(zeros(inputsize));
fprintf('Smoothing data 2nd time... \n')
tempImage(2:end-1,2:end-1,2:end-1)=1/27*InputImage(2:end-1,2:end-1,2:end-1)...%1
+1/27*InputImage(1:end-2,1:end-2,1:end-2)...%2
+1/27*InputImage(1:end-2,1:end-2,2:end-1)...%3
+1/27*InputImage(1:end-2,1:end-2,3:end)...%4
+1/27*InputImage(1:end-2,2:end-1,1:end-2)...%5
+1/27*InputImage(1:end-2,2:end-1,2:end-1)...%6
+1/27*InputImage(1:end-2,2:end-1,3:end)...%7
+1/27*InputImage(1:end-2,3:end,1:end-2)...%8
+1/27*InputImage(1:end-2,3:end,2:end-1)...%9
+1/27*InputImage(1:end-2,3:end,3:end)...%10
+1/27*InputImage(2:end-1,1:end-2,1:end-2)...%11
+1/27*InputImage(2:end-1,1:end-2,2:end-1)...%12
+1/27*InputImage(2:end-1,1:end-2,3:end)...%13
+1/27*InputImage(2:end-1,2:end-1,1:end-2)...%14
+1/27*InputImage(2:end-1,2:end-1,3:end)...%15
+1/27*InputImage(2:end-1,3:end,1:end-2)...%16
+1/27*InputImage(2:end-1,3:end,2:end-1)...%17
+1/27*InputImage(2:end-1,3:end,3:end)...%18
+1/27*InputImage(3:end,1:end-2,1:end-2)...%19
+1/27*InputImage(3:end,1:end-2,2:end-1)...%20
+1/27*InputImage(3:end,1:end-2,3:end)...%21
+1/27*InputImage(3:end,2:end-1,1:end-2)...%22
+1/27*InputImage(3:end,2:end-1,2:end-1)...%23
+1/27*InputImage(3:end,2:end-1,3:end)...%24
+1/27*InputImage(3:end,3:end,1:end-2)...%25
+1/27*InputImage(3:end,3:end,2:end-1)...%26
+1/27*InputImage(3:end,3:end,3:end);%27

InputImage(tempImage>0)=255;
InputImage(tempImage<=0)=0;


preprocessedData=InputImage;
fprintf('Cleaning data... \n')
CC = bwconncomp(preprocessedData);
for num=1:CC.NumObjects
     r(num) = length(CC.PixelIdxList{num});
end
[t,g]=max(r);
Itmp=zeros(size(preprocessedData));
for gi=1:length(g)
    Itmp(CC.PixelIdxList{g(gi)})=preprocessedData(CC.PixelIdxList{g(gi)});
end
preprocessedData=Itmp;