function sim=SimMat(f,v,patchgroup,fmesh)

for i=1:size(patchgroup,1)
    spine1_f=f(fmesh{patchgroup(i,1)},:);
    spine1_v=v(spine1_f(:),:);
    
    spine2_f=f(fmesh{patchgroup(i,2)},:);
    spine2_v=v(spine2_f(:),:);
    
    k1 = convhull(spine1_v(:,1),spine1_v(:,2));
    k2 = convhull(spine2_v(:,1),spine2_v(:,2));
    in1 = inhull(spine2_v(:,1:2),spine1_v(k1,1:2));
    rate1=size(find(in1==1),1)/size(spine2_v,1);
    in2 = inhull(spine1_v(:,1:2),spine2_v(k2,1:2));
    rate2=size(find(in2==1),2)/size(spine1_v,1);
%     if rate1>rate2
%         sim(patchgroup(i,1),patchgroup(i,2))=rate1;
%     else
%         sim(patchgroup(i,1),patchgroup(i,2))=rate2;
%     end
    sim(patchgroup(i,1),patchgroup(i,2))=(rate1+rate2)/2;
end
end
