function sim=SimilarityMatrix(f,v,mesh,candidates)
for i=1:size(mesh,2)
    spine_v=f(mesh{i},:);
    spine_v=unique(spine_v(:));
    spine_p=v(spine_v(:),:);
    spinecenters(i,:)=mean(spine_p(:,1:2));
end



sim=zeros([max(candidates(:)),max(candidates(:))]);
for i=1:size(candidates,1)
    temp=union(mesh{candidates(i,1)},mesh{candidates(i,2)});
    spine_v=f(temp,:);
    spine_v=unique(spine_v(:));
    spine_p=v(spine_v(:),:);
    spinecenter=mean(spine_p(:,1:2));
    
    sim(candidates(i,1),candidates(i,2))=distance(spinecenters(candidates(i,1),:),spinecenter)+distance(spinecenters(candidates(i,2),:),spinecenter);
    sim(candidates(i,2),candidates(i,1))=sim(candidates(i,1),candidates(i,2));
end
end