function [boundary,rings,sim,candidates]=similaritybetmesh(mesh,f,v)

for i=1:size(mesh,2)
    temp=f(mesh{i},:);
    faces=TriRep(temp,v(:,1),v(:,2),v(:,3));
    rings{i}= neighbors(faces);
    boundary{i}=mesh{i}(findboundary(rings{i}));  
 %   graph=shapeclassifier(rings{i},boundary{i});
end
candidates=[];
for i=1:size(mesh,2)
    for j=i+1:size(mesh,2)
        v1=f(boundary{i},:);
        v2=f(boundary{j},:);
        if ~isempty(intersect(v1(:),v2(:)))
            candidates=cat(1,candidates,[i,j]);
        end
    end
end
%id=muststitchmesh(mesh,f,candidates,v);
sim=SimilarityMatrix(f,v,mesh,candidates);

end
 