function matrix=generate_similarity_matrix(f,v)

% for i=1:size(f,1)
%     f_score(i)=(v_score(f(i,1))+v_score(f(i,2))+v_score(f(i,3)))/3;
% end
matrix=zeros(size(f,1),size(f,1));
faces=TriRep(f,v(:,1),v(:,2),v(:,3));
rings = neighbors(faces);

for i=1:size(rings,1)
    for j=1:3
        if ~isnan(rings(i,j))
%            matrix(i,rings(i,j))=abs(f_score(i)-f_score(rings(i,j)));
            
            p1=v(f(i,1),:);
            p2=v(f(i,2),:);
            p3=v(f(i,3),:);
            plane1=plane(p1,p2,p3);
            p1=v(f(rings(i,j),1),:);
            p2=v(f(rings(i,j),2),:);
            p3=v(f(rings(i,j),3),:);
            plane2=plane(p1,p2,p3);
            angle=dihedral_angle(plane1,plane2);
            
            if matrix(i,rings(i,j))==0
                matrix(i,rings(i,j))= exp(angle);
                matrix(rings(i,j),i)=matrix(i,rings(i,j));
            end
        end
    end
end
end
