function I = medfilt_3D_new_333(im_raw)

M = size(im_raw,1);
N = size(im_raw,2);
L = size(im_raw,3);

im_3D = zeros(M+2,N+4,L+4);
im_3D(2:end-1,3:end-2,3:end-2) = im_raw;

im_3D(1,:,:) = im_3D(2,:,:);
im_3D(end,:,:) = im_3D(end-1,:,:);
im_3D(:,1:2,:) = im_3D(:,4:-1:3,:);
im_3D(:,end-1:end,:) = im_3D(:,end-2:-1:end-3,:);
im_3D(:,:,1:2) = im_3D(:,:,4:-1:3);
im_3D(:,:,end-1:end) = im_3D(:,:,end-2:-1:end-3);


im_raw = im_3D;
[M,N,L] = size(im_raw);
for i=2:M-1
    for j=2:N-1
        for k=2:L-1
            TT = im_raw(i-1:i+1,j-1:j+1,k-1:k+1);
            TT = TT(:);
            ST = sort(TT);
            im_3D(i,j,k) = ST(14);
        end
    end
end

I = im_3D(2:end-1,3:end-2,3:end-2);
